package com.hosh.verse.common.quadtree;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.badlogic.gdx.math.Vector2;

import dacite.DBAnnotation;

public abstract class AbstractQuadNodeElement<T> {
	private T element;
	private Vector2 coords;

	public AbstractQuadNodeElement(final Vector2 coordinates, final T element) {
		this.coords = coordinates;
		this.element = element;
	}

	public AbstractQuadNodeElement(final T element) {
		this(new Vector2(), element);
	}

	public T getElement() {
		return element;
	}

	public Vector2 getCoordinates() {
		return coords;
	}

	/*public void guard1() {
		try {
			final Connection connect = DriverManager.getConnection("jdbc:mysql://localhost:3306/verse_db", "root", "2543120");
			final Statement stmt = connect.createStatement();
			final String query = "select area, gender from npc_location;";
			final ResultSet rs = stmt.executeQuery(query);

			final int area = rs.getInt("area");
			DBAnnotation.annoate("area", "npc_location", "area", true);
			final int gender = rs.getInt("gender");
			DBAnnotation.annoate("gender", "npc_location", "gender", true);

			int guard;
			if (area == 6) {
				if (gender == 1) {
					guard = 1;
					final String sql = "update npc_location set  guard = " + guard + "where area = " + area + " and gender = " + gender
							+ ";";
					stmt.executeUpdate(sql);
					DBAnnotation.annoate("guard", "npc_location", "guard", false);
				}
			}

		} catch (final SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void guard2() {
		try {
			final Connection connect = DriverManager.getConnection("jdbc:mysql://localhost:3306/verse_db", "root", "2543120");
			final Statement stmt = connect.createStatement();
			final String query = "select area, gender from npc_location;";
			final ResultSet rs = stmt.executeQuery(query);

			final int area = rs.getInt("area");
			DBAnnotation.annoate("area", "npc_location", "area", true);
			final int gender = rs.getInt("gender");
			DBAnnotation.annoate("gender", "npc_location", "gender", true);

			int guard;
			if (area == 6) {
				if (gender == 0) {
					guard = 1;
					final String sql = "update npc_location set  guard = " + guard + "where area = " + area + " and gender = " + gender
							+ ";";
					stmt.executeUpdate(sql);
					DBAnnotation.annoate("guard", "npc_location", "guard", false);
				}
			}

		} catch (final SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}*/
	
	public void basic_player1() {
		try {
		    final Connection connect = DriverManager.getConnection(
			    "jdbc:mysql://localhost:3306/verse_db", "root", "2543120");
		    final Statement stmt = connect.createStatement();
		    final String query = "select age, purchased from player;";
		    final ResultSet rs = stmt.executeQuery(query);

		    final int age = rs.getInt("age");
		    DBAnnotation.annoate("age", "player", "age", true);
		    final int purchased = rs.getInt("purchased");
		    DBAnnotation.annoate("purchased", "player", "purchased", true);
		  
		    int basic_player;
		    if (age > 10) 
		    	if(purchased < 500){
			basic_player = 1;
			final String sql = "update player set  basic_player = "
				+ basic_player + "where age = " + age + 
				" and purchased = " + purchased + ";";
			stmt.executeUpdate(sql);
			DBAnnotation.annoate("basic_player", "player",
				"basic_player", false);
		    }

		} catch (final SQLException e) { // TODO Auto-generated catch block
		    e.printStackTrace();
		}
	    }
	    
	    public void basic_player2() {
		try {
		    final Connection connect = DriverManager.getConnection(
			    "jdbc:mysql://localhost:3306/verse_db", "root", "2543120");
		    final Statement stmt = connect.createStatement();
		    final String query = "select age, purchased from player;";
		    final ResultSet rs = stmt.executeQuery(query);

		    final int age = rs.getInt("age");
		    DBAnnotation.annoate("age", "player", "age", true);
		    final int purchased = rs.getInt("purchased");
		    DBAnnotation.annoate("purchased", "player", "purchased", true);
		  
		    int basic_player;
		    if (age < 40) 
		    	if(purchased < 600){
			basic_player = 1;
			final String sql = "update player set  basic_player = "
				+ basic_player + "where age = " + age + 
				" and purchased = " + purchased + ";";
			stmt.executeUpdate(sql);
			DBAnnotation.annoate("basic_player", "player",
				"basic_player", false);
		    }

		} catch (final SQLException e) { // TODO Auto-generated catch block
		    e.printStackTrace();
		}
	    }
}
